// Autogenerated by tools/build/make_containers.py
// from tools/build/container_templates/container/DynamicListClassnameContainer.h
// Do not edit - any changes will be lost!

/**
 *  \file IMP/container/DynamicListTripletContainer.h
 *  \brief Store a list of ParticleTripletsTemp
 *
 *  Copyright 2007-2022 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_DYNAMIC_LIST_TRIPLET_CONTAINER_H
#define IMPCONTAINER_DYNAMIC_LIST_TRIPLET_CONTAINER_H

#include <IMP/container/container_config.h>
#include <IMP/object_macros.h>
#include <IMP/internal/DynamicListContainer.h>

IMPCONTAINER_BEGIN_NAMESPACE

//! Store a ParticleIndexTriplets
/** In contrast to ListTripletContainer, this list is designed to act
    as the output of a ScoreState or another container. The key difference
    is that it uses the passed Container to define the list of all
    possible contents of the container.
 */
class IMPCONTAINEREXPORT DynamicListTripletContainer :
#if defined(IMP_DOXYGEN) || defined(SWIG)
    public TripletContainer
#else
    public IMP::internal::DynamicListContainer<TripletContainer>
#endif
    {
  typedef IMP::internal::DynamicListContainer<TripletContainer> P;

 public:
  /** Constructs the dynamic list

      @param scope a container with a list of all possible particles that
                   are allowed to be dynamically added or removed in this
                   container
      @param name  the name of this container
  */
  DynamicListTripletContainer(Container *scope, std::string name =
                                                  "ListTripletContainer %1%");

  /** @name Methods to control the contained objects

      This container stores a list of Triplet objects. To manipulate
      the list use these methods.
   */
  /**@{*/
#if defined(SWIG) || defined(IMP_DOXYGEN)
  //! Add a single const ParticleIndexTriplet& to the container.
  void add(const ParticleIndexTriplet& vt);

  //! Add ParticleIndexTriplets to the container.
  void add(const ParticleIndexTriplets &c);

  //! Set the contents of the container to the given ParticleIndexTriplets.
  void set(ParticleIndexTriplets cp);

  //! Clear the contents of the container.
  void clear();
#endif

/**@}*/
#ifdef SWIG
  ParticleIndexTriplets get_indexes() const;
  ParticleIndexTriplets get_range_indexes() const;
  ModelObjectsTemp do_get_inputs() const;
  void do_apply(const TripletModifier *sm) const;
  void do_apply_moved(const TripletModifier *sm,
                      const ParticleIndexes &moved_pis,
                      const ParticleIndexes &reset_pis) const;
  ParticleIndexes get_all_possible_indexes() const;
#endif
  IMP_OBJECT_METHODS(DynamicListTripletContainer);
};

IMP_OBJECTS(DynamicListTripletContainer, DynamicListTripletContainers);

IMPCONTAINER_END_NAMESPACE

#endif /* IMPCONTAINER_DYNAMIC_LIST_TRIPLET_CONTAINER_H */
