// Autogenerated by tools/build/make_containers.py
// from tools/build/container_templates/container/ListClassnameContainer.h
// Do not edit - any changes will be lost!

/**
 *  \file IMP/container/ListTripletContainer.h
 *  \brief Store a list of ParticleIndexTriplets.
 *
 *  Copyright 2007-2022 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_LIST_TRIPLET_CONTAINER_H
#define IMPCONTAINER_LIST_TRIPLET_CONTAINER_H

#include <IMP/container/container_config.h>
#include <IMP/object_macros.h>
#include <IMP/internal/StaticListContainer.h>
#include <IMP/TripletContainer.h>
#include <IMP/TripletModifier.h>
#include <IMP/base_types.h>
#include <cereal/access.hpp>
#include <cereal/types/base_class.hpp>

IMPCONTAINER_BEGIN_NAMESPACE

//! Store a list of ParticleIndexTriplets
/** \note The order may change when particles are inserted
    as the list is maintained in sorted order.

    \note Changing the contents of the container is a fairly heavy
    weight operation as it resets part of the dependency graph. Use
    a DynamicListTripletContainer if you want to change the contents
    frequently (eg via a ScoreState).
 */
class IMPCONTAINEREXPORT ListTripletContainer :
#if defined(IMP_DOXYGEN) || defined(SWIG)
    public TripletContainer
#else
    public IMP::internal::StaticListContainer<TripletContainer>
#endif
    {
  typedef IMP::internal::StaticListContainer<TripletContainer> P;

 public:
  ListTripletContainer(Model *m, const ParticleIndexTriplets &contents,
                         std::string name = "ListTripletContainer%1%");

#ifndef IMP_DOXYGEN
  ListTripletContainer(Model *m,
                         std::string name = "ListTripletContainer %1%");
  ListTripletContainer(Model *m, const char *name);
  ListTripletContainer() {}

#endif
#if defined(SWIG) || defined(IMP_DOXYGEN)
  //! Add a single const ParticleIndexTriplet& to the container.
  void add(const ParticleIndexTriplet& vt);

  //! Add ParticleIndexTriplets to the container.
  void add(const ParticleIndexTriplets &c);

  //! Set the contents of the container to the given ParticleIndexTriplets.
  void set(ParticleIndexTriplets cp);

  //! Clear the contents of the container.
  void clear();
#endif

#ifdef SWIG
  ParticleIndexTriplets get_indexes() const;
  ParticleIndexTriplets get_range_indexes() const;
  ModelObjectsTemp do_get_inputs() const;
  void do_apply(const TripletModifier *sm) const;
  void do_apply_moved(const TripletModifier *sm,
                      const ParticleIndexes &moved_pis,
                      const ParticleIndexes &reset_pis) const;
  ParticleIndexes get_all_possible_indexes() const;

 private:
  std::size_t do_get_contents_hash() const;
#endif
  IMP_OBJECT_METHODS(ListTripletContainer);

  friend class cereal::access;

  template<class Archive> void serialize(Archive &ar) {
    ar(cereal::base_class<P>(this));
  }
  IMP_OBJECT_SERIALIZE_DECL(ListTripletContainer);
};

IMP_OBJECTS(ListTripletContainer, ListTripletContainers);

IMPCONTAINER_END_NAMESPACE

#endif /* IMPCONTAINER_LIST_TRIPLET_CONTAINER_H */
