// Autogenerated by tools/build/make_containers.py
// from tools/build/container_templates/container/ClassnameContainerSet.h
// Do not edit - any changes will be lost!

/**
 *  \file IMP/container/SingletonContainerSet.h
 *  \brief Store a set of SingletonContainers
 *
 *  Copyright 2007-2022 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_SINGLETON_CONTAINER_SET_H
#define IMPCONTAINER_SINGLETON_CONTAINER_SET_H

#include <IMP/container/container_config.h>
#include <IMP/SingletonContainer.h>
#include <IMP/container_macros.h>
#include <IMP/internal/container_helpers.h>
#include <IMP/scoped.h>

IMPCONTAINER_BEGIN_NAMESPACE

//! Stores a set of SingletonContainers
/** The input sets must be disjoint. This can change if there is
    demand for it.

    \usesconstraint
*/
class IMPCONTAINEREXPORT SingletonContainerSet : public SingletonContainer {
  Ints versions_;
  static SingletonContainerSet *get_set(SingletonContainer *c) {
    return dynamic_cast<SingletonContainerSet *>(c);
  }
  virtual std::size_t do_get_contents_hash() const override;

 public:
  //! Construct an empty set
  SingletonContainerSet(Model *m,
                        std::string name = "SingletonContainerSet %1%");

  SingletonContainerSet(const SingletonContainersTemp &pc,
                        std::string name = "SingletonContainerSet %1%");

  /** \brief apply modifier sm to all singleton containers */
  IMP_IMPLEMENT(void do_apply(const SingletonModifier *sm) const override);

  IMP_IMPLEMENT(void do_apply_moved(const SingletonModifier *sm,
                          const ParticleIndexes &moved_pis,
                          const ParticleIndexes &reset_pis) const override);

  template <class M>
  void apply_generic(const M *m) const {
    apply(m);
  }

  template <class M>
  void apply_generic_moved(const M *m, const ParticleIndexes &moved_pis,
                           const ParticleIndexes &reset_pis) const {
    apply_moved(m, moved_pis, reset_pis);
  }

  ParticleIndexes get_all_possible_indexes() const override;
  IMP_OBJECT_METHODS(SingletonContainerSet);

  /** @name Methods to control the nested container

      This container merges a set of nested containers. To add
      or remove nested containers, use the methods below.
  */
  /**@{*/
  IMP_LIST_ACTION(public, SingletonContainer, SingletonContainers,
                  singleton_container, singleton_containers,
                  SingletonContainer *, SingletonContainers,
  {
    obj->set_was_used(true);
    versions_.clear();
  },
                  {}, );
/**@}*/

#ifndef IMP_DOXYGEN
  ParticleIndexes get_indexes() const override;
  ParticleIndexes get_range_indexes() const override;
  ModelObjectsTemp do_get_inputs() const override;
#endif

 protected:
  //! Insert the contents of the container into output
  //! instead of output's current content
  virtual void get_indexes_in_place(ParticleIndexes& output)
    const override;
};

IMPCONTAINER_END_NAMESPACE

#endif /* IMPCONTAINER_SINGLETON_CONTAINER_SET_H */
