// Autogenerated by tools/build/make_containers.py
// from tools/build/container_templates/container/ClassnamesConstraint.h
// Do not edit - any changes will be lost!

/**
 *  \file IMP/container/SingletonsConstraint.h
 *  \brief Use a SingletonModifier applied to a ParticlesTemp to
 *  maintain an invariant
 *
 *  Copyright 2007-2023 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_SINGLETONS_CONSTRAINT_H
#define IMPCONTAINER_SINGLETONS_CONSTRAINT_H

#include <IMP/container/container_config.h>
#include <IMP/SingletonContainer.h>
#include <IMP/SingletonModifier.h>
#include <IMP/Constraint.h>
#include <IMP/object_macros.h>
#include <IMP/internal/ContainerConstraint.h>
#include <cereal/access.hpp>
#include <cereal/types/base_class.hpp>

IMPKERNEL_BEGIN_NAMESPACE
// for swig
class SingletonContainer;
class SingletonModifier;
IMPKERNEL_END_NAMESPACE

IMPCONTAINER_BEGIN_NAMESPACE
//! Apply a SingletonFunction to a SingletonContainer to maintain an invariant
/** The score state is passed up to two SingletonModifiers, one to
    apply before evaluation and the other after. The one after
    should take a DerivativeAccumulator as its last argument for
    SingletonModifier::apply() and will only be called if
    the score was computed with derivatives.

    \see core::SingletonConstraint
 */
class IMPCONTAINEREXPORT SingletonsConstraint :
#if defined(SWIG) || defined(IMP_DOXYGEN)
    public Constraint
#else
    public IMP::internal::ContainerConstraint<
        SingletonModifier, SingletonModifier, SingletonContainer>
#endif
    {
  typedef IMP::internal::ContainerConstraint<
      SingletonModifier, SingletonModifier, SingletonContainer> P;

  friend class cereal::access;
  template<class Archive> void serialize(Archive &ar) {
    ar(cereal::base_class<P>(this));
  }

  IMP_OBJECT_SERIALIZE_DECL(SingletonsConstraint);

 public:
  /** \param[in] c The Container to hold the elements to process
      \param[in] before The SingletonModifier to apply to all elements
      before evaluate.
      \param[in] after The SingletonModifier to apply to all elements
      after evaluate.
      \param[in] name The object name
   */
  SingletonsConstraint(SingletonModifier *before, SingletonModifier *after,
                       SingletonContainerAdaptor c,
                       std::string name = "SingletonsConstraint %1%")
      : P(before, after, c, name) {}

  SingletonsConstraint() {}

#if defined(IMP_DOXYGEN) || defined(SWIG)
 protected:
  void do_update_attributes();
  void do_update_derivatives(DerivativeAccumulator *da);
  virtual ModelObjectsTemp do_get_inputs() const;
  virtual ModelObjectsTemp do_get_outputs() const;
  IMP_OBJECT_METHODS(SingletonsConstraint);
#endif
};

IMP_OBJECTS(SingletonsConstraint, SingletonsConstraints);

IMPCONTAINER_END_NAMESPACE

#endif /* IMPCONTAINER_SINGLETONS_CONSTRAINT_H */
