// Autogenerated by tools/build/make_containers.py
// from tools/build/container_templates/core/ClassnameConstraint.h
// Do not edit - any changes will be lost!

/**
 *  \file IMP/core/QuadConstraint.h
 *  \brief Use a QuadModifier applied to a ParticleQuadsTemp to
 *  maintain an invariant
 *
 *  Copyright 2007-2023 IMP Inventors. All rights reserved.
 */

#ifndef IMPCORE_QUAD_CONSTRAINT_H
#define IMPCORE_QUAD_CONSTRAINT_H

#include <IMP/core/core_config.h>
#include <IMP/internal/TupleConstraint.h>
#include <IMP/QuadModifier.h>
#include <IMP/QuadDerivativeModifier.h>
#include <cereal/access.hpp>
#include <cereal/types/base_class.hpp>

IMPCORE_BEGIN_NAMESPACE
//! Apply a QuadFunction to a Quad
/** The score state is passed up to two QuadModifiers, one to
    apply before evaluation and the other after. The one after
    should take a DerivativeAccumulator as its last argument for
    QuadModifier::apply() and will only be called if
    the score was computed with derivatives.

    \see container::QuadsConstraint
 */
class QuadConstraint :
#if defined(IMP_DOXYGEN) || defined(SWIG)
    public Constraint
#else
    public IMP::internal::TupleConstraint<QuadModifier,
                                                  QuadDerivativeModifier>
#endif
    {

  friend class cereal::access;
  template<class Archive> void serialize(Archive &ar) {
    ar(cereal::base_class<
                    IMP::internal::TupleConstraint<QuadModifier,
                                        QuadDerivativeModifier> >(this));
  }
  IMP_OBJECT_SERIALIZE_DECL(QuadConstraint);

 public:
  QuadConstraint(QuadModifier *before,
                      QuadDerivativeModifier *after, Model *m,
                      const ParticleIndexQuad& vt,
                      std::string name = "QuadConstraint %1%",
                      bool can_skip=false)
      : IMP::internal::TupleConstraint<
            QuadModifier, QuadDerivativeModifier>(before, after, m,
                                                            vt, name,
                                                            can_skip) {}

  QuadConstraint() {}

#if defined(IMP_DOXYGEN) || defined(SWIG)
 protected:
  void do_update_attributes();
  void do_update_derivatives(DerivativeAccumulator *da);
  virtual ModelObjectsTemp do_get_inputs() const;
  virtual ModelObjectsTemp do_get_outputs() const;
  IMP_OBJECT_METHODS(QuadConstraint);
#endif
};

IMPCORE_END_NAMESPACE

#endif /* IMPCORE_QUAD_CONSTRAINT_H */
