// Autogenerated by tools/build/make_containers.py
// from tools/build/container_templates/core/ClassnameRestraint.h
// Do not edit - any changes will be lost!

/**
 *  \file IMP/core/QuadRestraint.h
 *  \brief Apply a QuadScore to a Quad.
 *
 *  Copyright 2007-2023 IMP Inventors. All rights reserved.
 *
 */

#ifndef IMPCORE_QUAD_RESTRAINT_H
#define IMPCORE_QUAD_RESTRAINT_H

#include <IMP/core/core_config.h>

#include <IMP/internal/TupleRestraint.h>
#include <IMP/QuadScore.h>

#include <iostream>
#include <cereal/access.hpp>
#include <cereal/types/base_class.hpp>

IMPCORE_BEGIN_NAMESPACE

//! Applies a QuadScore to a Quad.
/** This restraint stores a Quad.
    \see QuadRestraint
 */
class QuadRestraint :
#if defined(SWIG) || defined(IMP_DOXYGEN)
    public Restraint
#else
    public IMP::internal::TupleRestraint<QuadScore>
#endif
    {
  friend class cereal::access;

  template<class Archive> void serialize(Archive &ar) {
    ar(cereal::base_class<
                    IMP::internal::TupleRestraint<QuadScore> >(this));
  }
  IMP_OBJECT_SERIALIZE_DECL(QuadRestraint);
 public:
  //! Create the restraint.
  /** This function takes the function to apply to the
      stored Quad and the Quad.
   */
  QuadRestraint(Model *m, QuadScore *ss, const ParticleIndexQuad& vt,
                     std::string name = "QuadRestraint %1%")
      : IMP::internal::TupleRestraint<QuadScore>(ss, m, vt, name) {
  }
  QuadRestraint() {}

#if defined(SWIG) || defined(IMP_DOXYGEN)
 protected:
  double unprotected_evaluate(IMP::DerivativeAccumulator *accum) const;
  IMP::ModelObjectsTemp do_get_inputs() const;
  IMP_OBJECT_METHODS(QuadRestraint)
#endif
};

IMPCORE_END_NAMESPACE

#endif /* IMPCORE_QUAD_RESTRAINT_H */
