%import "RMF.i"
%{
#include "RMF.h"
%}

/* Tell swig how to treat various types when moving them to and from python. Among other
   things, they tell swig how to convert collections of C++ objects (eg ExampleRestraints)
   into python lists and back.

   IMP_SWIG_OBJECT, IMP_SWIG_VALUE and IMP_SWIG_DECORATOR lines need to appear before any
   %include lines as well as any inline C++ code (or at least any such code which uses
   the types in question).

*/
IMP_SWIG_VALUE(IMP::cnmultifit, AlignSymmetric, AlignSymmetrics);
IMP_SWIG_VALUE(IMP::cnmultifit, CnSymmAxisDetector, CnSymmAxisDetectors);
IMP_SWIG_VALUE(IMP::cnmultifit, MolCnSymmAxisDetector, MolCnSymmAxisDetectors);


/* Wrap our own classes. Each header in the module should be listed here with a
   %include line.*/
%include "IMP/cnmultifit/CnSymmAxisDetector.h"
%include "IMP/cnmultifit/MolCnSymmAxisDetector.h"
%include "IMP/cnmultifit/AlignSymmetric.h"
%include "IMP/cnmultifit/symmetry_utils.h"
%include "IMP/cnmultifit/symmetric_multifit.h"
%include "IMP/cnmultifit/cn_rmsd.h"

/* All scripts that can be called from the cnmultifit application */
%pythoncode %{
_all_commands = ["build", "rmsd", "surface",
                 "param", "chimera_models"]
%}
